module CDrillingConsole
    use CDrillingConsoleVariables
    use SimulationVariables
    use SimulationVariables 
    ! use CSimulationVariables
    use CLog4
    use CLog3
    implicit none    
    public    
    contains  


    subroutine DrillingConsoleToJson(parent)

        type(json_value),pointer :: parent
        type(json_core) :: json
        type(json_value),pointer :: p

        ! 1. create new node
        call json%create_object(p,'Drilling')
        call json%add(p,"AssignmentSwitch",data%EquipmentControl%DrillingConsole%AssignmentSwitch)
        call json%add(p,"EmergencySwitch",data%EquipmentControl%DrillingConsole%EmergencySwitch)
        call json%add(p,"RTTorqueLimitKnob",data%EquipmentControl%DrillingConsole%RTTorqueLimitKnob)
        call json%add(p,"MP1CPSwitchI",data%EquipmentControl%DrillingConsole%MP1CPSwitchI)
        call json%add(p,"MP1CPSwitchT",data%EquipmentControl%DrillingConsole%MP1CPSwitchT)
        call json%add(p,"MP1CPSwitch",data%EquipmentControl%DrillingConsole%MP1CPSwitch)
        call json%add(p,"MP1ThrottleUpdate",data%EquipmentControl%DrillingConsole%MP1ThrottleUpdate)
        call json%add(p,"MP1Throttle",data%EquipmentControl%DrillingConsole%MP1Throttle)
        call json%add(p,"MP2SwitchI",data%EquipmentControl%DrillingConsole%MP2SwitchI)
        call json%add(p,"MP2SwitchT",data%EquipmentControl%DrillingConsole%MP2SwitchT)
        call json%add(p,"MP2Switch",data%EquipmentControl%DrillingConsole%MP2Switch)
        call json%add(p,"MP2ThrottleUpdate",data%EquipmentControl%DrillingConsole%MP2ThrottleUpdate)
        call json%add(p,"MP2Throttle",data%EquipmentControl%DrillingConsole%MP2Throttle)
        call json%add(p,"DWSwitch",data%EquipmentControl%DrillingConsole%DWSwitch)
        call json%add(p,"DWThrottle",data%EquipmentControl%DrillingConsole%DWThrottle)
        call json%add(p,"RTSwitch",data%EquipmentControl%DrillingConsole%RTSwitch)
        call json%add(p,"RTThrottle",data%EquipmentControl%DrillingConsole%RTThrottle)
        call json%add(p,"DWBreak",data%EquipmentControl%DrillingConsole%DWBreak)
        call json%add(p,"PreviousDWBreak",data%EquipmentControl%DrillingConsole%PreviousDWBreak)
        call json%add(p,"ForceBreak",data%EquipmentControl%DrillingConsole%ForceBreak)
        call json%add(p,"DWAcceleretor",data%EquipmentControl%DrillingConsole%DWAcceleretor)
        call json%add(p,"DWTransmisionLever",data%EquipmentControl%DrillingConsole%DWTransmisionLever)
        call json%add(p,"DWPowerLever",data%EquipmentControl%DrillingConsole%DWPowerLever)
        call json%add(p,"TongLever",data%EquipmentControl%DrillingConsole%TongLever)
        call json%add(p,"RTTransmissionLever",data%EquipmentControl%DrillingConsole%RTTransmissionLever)
        call json%add(p,"DWClutchLever",data%EquipmentControl%DrillingConsole%DWClutchLever)
        call json%add(p,"EddyBreakLever",data%EquipmentControl%DrillingConsole%EddyBreakLever)
        call json%add(p,"AutoDW",data%EquipmentControl%DrillingConsole%AutoDW)
        call json%add(p,"GEN1",data%EquipmentControl%DrillingConsole%GEN1)
        call json%add(p,"GEN2",data%EquipmentControl%DrillingConsole%GEN2)
        call json%add(p,"GEN3",data%EquipmentControl%DrillingConsole%GEN3)
        call json%add(p,"GEN4",data%EquipmentControl%DrillingConsole%GEN4)
        call json%add(p,"Permission_OpenKellyCock",data%EquipmentControl%DrillingConsole%Permission_OpenKellyCock)
        call json%add(p,"OpenKellyCock",data%EquipmentControl%DrillingConsole%OpenKellyCock)
        call json%add(p,"Permission_CloseKellyCock",data%EquipmentControl%DrillingConsole%Permission_CloseKellyCock)
        call json%add(p,"CloseKellyCock",data%EquipmentControl%DrillingConsole%CloseKellyCock)
        call json%add(p,"Permission_OpenSafetyValve",data%EquipmentControl%DrillingConsole%Permission_OpenSafetyValve)
        call json%add(p,"OpenSafetyValve",data%EquipmentControl%DrillingConsole%OpenSafetyValve)
        call json%add(p,"Permission_CloseSafetyValve",data%EquipmentControl%DrillingConsole%Permission_CloseSafetyValve)
        call json%add(p,"CloseSafetyValve",data%EquipmentControl%DrillingConsole%CloseSafetyValve)
        call json%add(p,"Permission_IRSafetyValve",data%EquipmentControl%DrillingConsole%Permission_IRSafetyValve)
        call json%add(p,"IRSafetyValve",data%EquipmentControl%DrillingConsole%IRSafetyValve)
        call json%add(p,"Permission_IRIBop",data%EquipmentControl%DrillingConsole%Permission_IRIBop)
        call json%add(p,"IRIBop",data%EquipmentControl%DrillingConsole%IRIBop)
        call json%add(p,"LatchPipe",data%EquipmentControl%DrillingConsole%LatchPipe)
        call json%add(p,"UnlatchPipe",data%EquipmentControl%DrillingConsole%UnlatchPipe)
        call json%add(p,"Swing",data%EquipmentControl%DrillingConsole%Swing)
        call json%add(p,"FillMouseHole",data%EquipmentControl%DrillingConsole%FillMouseHole)
        call json%add(p,"Slips",data%EquipmentControl%DrillingConsole%Slips)
        call json%add(p,"BrakeLeverCoefficient",data%EquipmentControl%DrillingConsole%BrakeLeverCoefficient)
        call json%add(p,"HideDrillingBrake",data%EquipmentControl%DrillingConsole%HideDrillingBrake)
        call json%add(p,"ParkingBrakeBtn",data%EquipmentControl%DrillingConsole%ParkingBrakeBtn)
        call json%add(p,"ParkingBrakeLed",data%EquipmentControl%DrillingConsole%ParkingBrakeLed)
        call json%add(p,"GEN1LED",data%EquipmentControl%DrillingConsole%GEN1LED)
        call json%add(p,"GEN2LED",data%EquipmentControl%DrillingConsole%GEN2LED)
        call json%add(p,"GEN3LED",data%EquipmentControl%DrillingConsole%GEN3LED)
        call json%add(p,"GEN4LED",data%EquipmentControl%DrillingConsole%GEN4LED)
        call json%add(p,"SCR1LED",data%EquipmentControl%DrillingConsole%SCR1LED)
        call json%add(p,"SCR2LED",data%EquipmentControl%DrillingConsole%SCR2LED)
        call json%add(p,"SCR3LED",data%EquipmentControl%DrillingConsole%SCR3LED)
        call json%add(p,"SCR4LED",data%EquipmentControl%DrillingConsole%SCR4LED)
        call json%add(p,"MP1BLWR",data%EquipmentControl%DrillingConsole%MP1BLWR)
        call json%add(p,"MP2BLWR",data%EquipmentControl%DrillingConsole%MP2BLWR)
        call json%add(p,"DWBLWR",data%EquipmentControl%DrillingConsole%DWBLWR)
        call json%add(p,"RTBLWR",data%EquipmentControl%DrillingConsole%RTBLWR)
        call json%add(p,"PWRLIM",data%EquipmentControl%DrillingConsole%PWRLIM)
        call json%add(p,"PWRLIMMTR",data%EquipmentControl%DrillingConsole%PWRLIMMTR)
        call json%add(p,"RTTorqueLimitGauge",data%EquipmentControl%DrillingConsole%RTTorqueLimitGauge)
        call json%add(p,"AutoDWLED",data%EquipmentControl%DrillingConsole%AutoDWLED)
        call json%add(p,"GEN1BTNLED",data%EquipmentControl%DrillingConsole%GEN1BTNLED)
        call json%add(p,"GEN2BTNLED",data%EquipmentControl%DrillingConsole%GEN2BTNLED)
        call json%add(p,"GEN3BTNLED",data%EquipmentControl%DrillingConsole%GEN3BTNLED)
        call json%add(p,"GEN4BTNLED",data%EquipmentControl%DrillingConsole%GEN4BTNLED)
        call json%add(p,"OpenKellyCockLed",data%EquipmentControl%DrillingConsole%OpenKellyCockLed)
        call json%add(p,"CloseKellyCockLed",data%EquipmentControl%DrillingConsole%CloseKellyCockLed)
        call json%add(p,"OpenSafetyValveLed",data%EquipmentControl%DrillingConsole%OpenSafetyValveLed)
        call json%add(p,"CloseSafetyValveLed",data%EquipmentControl%DrillingConsole%CloseSafetyValveLed)
        call json%add(p,"IRSafetyValveLed",data%EquipmentControl%DrillingConsole%IRSafetyValveLed)
        call json%add(p,"IRIBopLed",data%EquipmentControl%DrillingConsole%IRIBopLed)
        call json%add(p,"LatchPipeLED",data%EquipmentControl%DrillingConsole%LatchPipeLED)
        call json%add(p,"UnlatchPipeLED",data%EquipmentControl%DrillingConsole%UnlatchPipeLED)
        call json%add(p,"SwingLed",data%EquipmentControl%DrillingConsole%SwingLed)
        call json%add(p,"FillMouseHoleLed",data%EquipmentControl%DrillingConsole%FillMouseHoleLed)

        call json%add(parent,p)
    end subroutine
    
end module CDrillingConsole