subroutine Drawworks_StartUp

    use CDrillingConsoleVariables
    use SimulationVariables
    use SimulationVariables
    use CHoistingVariables
    use SimulationVariables
    use SimulationVariables !@
    !use CWarnings
    
	IMPLICIT NONE
    
    
    
    data%State%Drawworks%RateChange = 193.d0                       ! [rpm/s?]   !??????? motaghayere voroudi
    
    
    
    !===> Hook Height
    data%State%Drawworks%Hook_Height_ini              = 75.0d0                             ![ft]
    data%State%Drawworks%Hook_Height_ini_graph_output = -1.54090d0                         ![ft]
    data%State%Drawworks%Hook_Height_inim             = 0.3048d0*data%State%Drawworks%Hook_Height_ini ![m]
    data%State%Drawworks%Hook_Height                  = data%State%Drawworks%Hook_Height_inim         ![m]
    data%State%Drawworks%Hook_Height_final            = 75.d0                              ![ft]
    data%State%Drawworks%TDHookHeight                 = 75.d0                              ![ft]
    
    
    
    !===> Drum (Drawworks) Diameter
    data%State%Drawworks%Diameter = 2.50d0                         ![ft]
    data%State%Drawworks%Diameter = 0.3048d0*data%State%Drawworks%Diameter    ![m]
    
    
    
    !===> Number of Line
    data%State%Drawworks%NumberOfLine = data%Configuration%Hoisting%NumberOfLine
    
    
    
    !===> Simulation time step
    data%State%Drawworks%time_step = 0.10d0                        ![s]
    
    
    
    !===> Initial Values
    data%State%Drawworks%w_drum               = 0.d0
    data%State%Drawworks%w_old_drum           = 0.d0
    data%State%Drawworks%motion               = 0
    data%State%Drawworks%K_Throttle           = 0
    data%State%Drawworks%StringIsBottomOfWell = 0                  ! 1= string is at the bottom of the well
    !data%State%Drawworks%CrownCollision      = 0
    !data%State%Drawworks%FloorCollision      = 0
    
    
    
    
end subroutine Drawworks_StartUp