MODULE Pumps_VARIABLES
    
    IMPLICIT NONE
    PUBLIC
    
    
    
    
    ! REAL , PARAMETER :: pi=3.14159265d0
    
    
    Type, public:: Pumps_Var
        REAL :: Total_Pump_GPM, Total_Pump_SPM, Total_Stroke_Counter_For_Plot
    end Type Pumps_Var
    Type(Pumps_Var) :: MPumps
    
    
    
!****************************************************************************************************    
!**************** Define PUMP Array ************************************************************
    TYPE, PUBLIC :: Pump_Var
    
!*****  Pump_VARIABLES  ***************************
    INTEGER :: AssignmentSwitchh, Switch, K_throttle
    INTEGER :: PowerFailMalf , BlowPopOffMalf , SPMGaugeMalf , Failure

    REAL :: Throttle, RateChange
    REAL :: Mech_Efficiency, Vol_Efficiency, Trans_Ratio
    REAL :: StandPipe_Pressure , Max_Pressure
    REAL :: Speed, N_new, N_old, MaxSPM
    REAL :: Flow_Rate, Hydraulic_HorsePower, Max_Horsepower, FlowRatePerSTK, Max_FlowRate, HorsePower
    REAL :: time_step
    
   
    
    INTEGER :: BLWR       ! 1=On , 0=Off
    INTEGER :: Open_Close ! 1=Open , 0=Close
    
!*************  Sound_VARIABLES  **********************
    INTEGER :: SoundSPM
    Logical :: SoundBlower
    
    END TYPE Pump_Var

!***********************************************************************************************   
!***********************************************************************************************
    
END MODULE Pumps_VARIABLES