subroutine RTable_StartUp

    Use SimulationVariables
    
	IMPLICIT NONE
    
    
        
    data%State%RTable%Inertia_Moment  = 23.261341d0       ! 23.261341[kg.m^2] = 552[lb.ft^2]
    data%State%RTable%Mech_Efficiency = 0.93d0
    data%State%RTable%RateChange      = 1.d0              ![Hz/s]     !??????? motaghayere voroudi
    data%State%RTable%High_Conv_Ratio = 4.825d0
    data%State%RTable%Low_Conv_Ratio  = 7.31d0
    data%State%RTable%time_step       = 0.1d0             ![s]
    data%State%RTable%MaxRPM          = 200.d0            ![RPM]      !??????? motaghayere voroudi
    data%State%RTable%MaxTorque       = 1500.d0           ![ft.lbf]   !??????? motaghayere voroudi
    
    
    
    data%State%RTable%RateChange    = data%State%RTable%RateChange*60.d0   ![RPM/s]         ![cycle/min]=[RPM]     !1[Hz]=60[RPM]
    data%State%RTable%J_coef        = data%State%RTable%Inertia_Moment+(1.d0*(data%State%RTable%Inertia_Moment)) 
    data%State%RTable%Conv_Ratio    = data%State%RTable%Low_Conv_Ratio
    data%State%RTable%String_JCoef  = 0.d0  
    data%State%RTable%Torque        = 0.d0
    data%State%RTable%K_throttle    = 0
    data%State%RTable%Speed         = 0.d0
    data%State%RTable%TorqueGaugeOutput = 0.d0
    call RTable_OffMode
    
    
    
end subroutine RTable_StartUp