MODULE RTable_VARIABLES
    
    IMPLICIT NONE
    PUBLIC
    
    
    ! REAL, PARAMETER :: pi=3.14159265

    
    
!****************************************************************************************************
!**************** Define Rotary Table Array ****************************************************
    TYPE, PUBLIC :: RTable_Var
    
!*********  RTable_VARIABLES  *************************
    INTEGER :: AssignmentSwitch , Switch , K_throttle , RotaryMode
    INTEGER :: MotorFaileMalf , OverideTorqueLimitMalf , RpmGaugeMalf , TorqueGaugeMalf , TorqueLimitGaugeMalf    
    REAL(8) :: RpmGaugeOutput , TorqueGaugeOutput
    REAL :: Throttle, RateChange
    REAL :: Speed, Inertia_Moment, Mech_Efficiency, Torque, MaxRPM, MaxTorque
    REAL :: Conv_Ratio, High_Conv_Ratio, Low_Conv_Ratio
    REAL :: String_Torque, String_JCoef
    REAL :: time_step, J_coef
    REAL :: N_new, N_old, N_ref   ! N(rpm)  ,  w(rad/s)
        
!*********  Traction Motor_VARIABLES  *****************
    
    
!******************************************************    
    INTEGER :: BLWR     ! On=1 , Off=0
 
!*************  Sound_VARIABLES  **********************
    INTEGER :: SoundRPM
    Logical :: SoundBlower
    END TYPE RTable_Var

!***********************************************************************************************   
!****************************************************************************************************    
    
END MODULE RTable_VARIABLES