MODULE TopDrive_VARIABLES
    
    IMPLICIT NONE
    PUBLIC
    
    
    ! REAL, PARAMETER :: pi=3.14159265d0
    
    
!****************************************************************************************************    
!**************** Define Top Drive Array ****************************************************
    TYPE, PUBLIC :: TDS_Var
    
!*****  TopDrive_VARIABLES  *************************
    INTEGER :: MotorFaileMalf , OverideTorqueLimitMalf , PowerState , OldPowerMode , DrillTorqueState
        
    REAL :: Speed, Inertia_Moment, Torque, RpmKnob, TorqueLimitKnob
    REAL :: Conv_Ratio, High_Conv_Ratio, Low_Conv_Ratio, RateChange, N_new, N_old, N_ref, TDS_wOld         ! N[rpm]  ,  w[rad/s]
    REAL :: RpmGaugeOutput, RPMUnityOutput, TorqueGaugeOutput, MaxRPM, MaxTorque
    REAL :: String_Torque, String_JCoef, J_coef
    REAL :: time_step
    
    
    
    INTEGER :: PowerLed     ! 1=On , 0=Off
    INTEGER :: OperationFaultLed
    
!*************  Sound_VARIABLES  **********************
    INTEGER :: SoundRPM
    Logical :: SoundBlower
    
    

    END TYPE TDS_Var
!***********************************************************************************************   
!****************************************************************************************************    
 
    
    
    
END MODULE