MODULE TD_GeneralData
    
    Use CDownHoleTypes
    
    IMPLICIT NONE
    PUBLIC
    
    
    
!************************************************************************************************************************************
!====================================================
!                 General Info
!====================================================
!=====> Time Info
    TYPE , PUBLIC :: TD_GeneralInfo
        REAL    :: TimeStep
        !=====> Problems
        INTEGER :: WeightIndicatorMalf
    END TYPE TD_GeneralInfo
!************************************************************************************************************************************

    
        
!************************************************************************************************************************************
!=====> BOP Info
    TYPE , PUBLIC :: TD_BOPInfo
        REAL(8)    :: AboveAnnularDiam , AnnularPreventerDiam , UpperRamDiam , LowerRamDiam , BlindRamDiam , KillDiam
        REAL(8) , Dimension(6) :: BOPHeight , BOPDiam
        REAL(8) , Dimension(4) :: BOPRamDiam
        REAL(8)                :: BOPThickness , AnnularFillingFinal
        INTEGER , Dimension(4) :: BOPCondition
        INTEGER , Dimension(6) :: BOPElementNo
        INTEGER , Dimension(6) :: BOPConnectionPossibility    ! 0:impossible   , 1:possible(for DrillPipe Element)
    END TYPE TD_BOPInfo
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************
    !TYPE , PUBLIC  :: TD_BOPElementData
    !    INTEGER    :: CType
    !    REAL(8)    :: TopDepth , DownDepth
    !END TYPE TD_BOPElementData
!************************************************************************************************************************************

    
    

    
END MODULE TD_GeneralData