MODULE TD_StringConnectionData
    
    IMPLICIT NONE
    PUBLIC
    
    
    
!************************************************************************************************************************************
!====================================================
!             String Connection Info
!====================================================
    TYPE , PUBLIC :: TD_StringconnectionInfo
        INTEGER    :: StringConnectionMode , KellyDriveTypeMode , OldOperationCondition , FluidStringConnectionMode
        REAL(8)    :: ConnectionHeight , TouchConnectionHeight , RigidConnectionHeight , GRigidConnectionHeight , StringVelocity
        REAL(8)    :: HookHeightOld , HookHeight , HookVelocity
        REAL(8)    :: ElevatorHeight , ElevatorConst
        REAL(8)    :: SafetyValveLength , IBOPLength , KellyElementID , KellyElementOD
        REAL(8)    :: KellyConnectionHeight , KellyConst , KellyElementConst
        REAL(8)    :: TDSHeight , TDSElevatorHeight , TDSLength , TDSElevatorLength , TDSToolJointLength , TDSElevatorToolLength
        REAL(8)    :: TDSElevatorECG , ElevatorECG
    END TYPE TD_StringconnectionInfo
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************    
!====================================================
!             Weight Indicator Info
!====================================================
    TYPE , PUBLIC :: TD_LoadInfo
        INTEGER    :: NumOfCables
        REAL(8)    :: WeightIndicator
        REAL(8)    :: WeightTB , WeightTD , KellyWeight
        INTEGER    :: ZeroStringSpeed
        REAL(8)    :: DrawworksLoadInput
    END TYPE TD_LoadInfo
!************************************************************************************************************************************

    
    
    
    
END MODULE TD_StringConnectionData