MODULE TD_WellGeometry
    
    IMPLICIT NONE
    PUBLIC
    
    ! REAL(8) , PARAMETER :: pi=3.14159265d0
    
    
    
!************************************************************************************************************************************
!====================================================
!                Well Geometry Info
!====================================================
    TYPE, PUBLIC :: TD_WellGeneralInfo
        INTEGER :: WellIntervalsCount
        REAL(8) :: WellTotalLength , WellTotalVerticalLength
    END TYPE TD_WellGeneralInfo
!************************************************************************************************************************************

        
        
!************************************************************************************************************************************        
    TYPE, PUBLIC :: TD_WellGeometryData
        INTEGER  :: HoleType
        REAL(8)  :: StartAngle , EndAngle , IntervalLength , VerticalDepth , TopDepth , DownDepth , RCurvature
    END TYPE TD_WellGeometryData
!************************************************************************************************************************************

    
    
    
    
END MODULE TD_WellGeometry